"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/for-each"));

var _includes = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/includes"));

var _filter = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/filter"));

var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/map"));

var _path = _interopRequireDefault(require("path"));

var _internal = require("@redwoodjs/internal");

const WEB_PAGES_DIR = (0, _internal.getPaths)().web.pages;

module.exports = function ({
  types: t
}) {
  // Process the dir to find all Page dependencies.
  let deps = (0, _internal.processPagesDir)();
  return {
    visitor: {
      // Remove any deps that have been explicitly declared in the Routes file. When one
      // is present, the user is requesting that the module be included in the main
      // bundle.
      ImportDeclaration(path) {
        var _context;

        const declaredImports = (0, _map.default)(_context = path.node.specifiers).call(_context, specifier => specifier.local.name);
        deps = (0, _filter.default)(deps).call(deps, dep => !(0, _includes.default)(declaredImports).call(declaredImports, dep.const));
      },

      Program: {
        exit(nodePath) {
          // Prepend all imports to the top of the file
          (0, _forEach.default)(deps).call(deps, dep => {
            const basename = _path.default.basename(dep.const);

            const importFile = _path.default.join(WEB_PAGES_DIR, basename);

            nodePath.node.body.unshift(t.variableDeclaration('const', [t.variableDeclarator(t.identifier(dep.const), t.objectExpression([t.objectProperty(t.identifier('name'), t.stringLiteral(dep.const)), t.objectProperty(t.identifier('loader'), t.arrowFunctionExpression([], t.callExpression(t.identifier('import'), [t.stringLiteral(importFile)])))]))]));
          });
        }

      }
    }
  };
};